#ifndef	HTMFA_H

#define	HTMFA_H
#include "htmtree.h"

enum hibakod { FILEHIBA=2, MEMHIBA=3};

#if	0

node    ::= { szoveg | tag }...
szoveg  ::= { TXT | comment }...
comment ::= <!-- TXT -->
tag     ::= fejlec node [zarotag]
fejlec  ::= < NYITOTAG { opcio }... >
zarotag ::= < / NYITOTAG >
opcio   ::= OPTNEV = TXT | OPTNEV = " TXT "

#endif	

enum txttip { SZOVEG, COMMENT };
struct charstr {
	enum txttip tip;
	char *cim;
	};
struct szovegstr {	// szoveg  ::= { TXT | comment }...
	int darab;
	struct charstr **txt;
	};

struct opciostr {	// opcio   ::= OPTNEV = TXT | OPTNEV = " TXT "
	char *nev;
	char *opcio;
	};

struct tagstr {		// tag     ::= fejlec node [zarotag]
	enum htmlkod kod;
	int  optszam;	// az opciok szama
	struct opciostr **optomb;
	struct htmstr *node;	// lehet NULL
	unsigned zaroflg:1;	// 1: van zarotag
	};

struct nodestr {
	struct szovegstr *szov;
	struct tagstr *tag;
	};	// a ket mutato pontosan egyike NULL
struct htmstr {		// node    ::= { szoveg | tag }...
	int darab;
	struct nodestr **ag;	// ha darab==0, nincs feltoltve
	struct htmstr *szulo;
	};

extern struct htmstr gyoker;

extern struct htmstr *htmfa(char *fnev);
			// Felepiti a fat, visszaadja a gyoker cimet
extern void htmfaveg(struct htmstr *gyoker);	// felszabaditja a htmfa foglalta memoriat
extern void listfa(struct htmstr *alfa,int szint);
extern void tagki(struct tagstr *tag,int szint);
extern void opcioki(struct tagstr *tag,int szint);
extern void szovegki(struct szovegstr *tag,int szint);
extern int  szintgen(int szint);	// helykozgeneralas
	
#endif
