#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
//#include <libgyl.h>
#include <libgyim.h>

static void olvas(FILE *fp,char *puffer,int hossz);

int main(int argc, char *argv[])	// stdout-ra irja a hivatkozatlan,
{		// stderr-re a hivatkozott, de nem letezo file-ok listajat
FILE *fplist, *fpxref;
char pflist[FILENAME_MAX],pxlist[FILENAME_MAX];
int flg;
struct stat buf;

if(argc < 3)
	{
	fprintf(stderr,"Hivas: htmhasonl filelista xreflista\n");
	return(1);
	}
//fplist = flnyit(argv[1],0); olvas(fplist,pflist,sizeof(pflist));
//fpxref = flnyit(argv[2],0); olvas(fpxref,pxlist,sizeof(pxlist));
fplist = filenyit(argv[1],"r"); olvas(fplist,pflist,sizeof(pflist));
fpxref = filenyit(argv[2],"r"); olvas(fpxref,pxlist,sizeof(pxlist));
while(! feof(fplist) || ! feof(fpxref))
	{
	flg = feof(fpxref)? -1: feof(fplist)? 1: strcmp(pflist,pxlist);
	if(flg < 0)
		printf("%s\n",pflist);
	if(flg > 0 && stat(pxlist,&buf) != 0)	// lehet, hogy nem a vizsgalt
		fprintf(stderr,"%s\n",pxlist);	// konyvtarban van a file
	if(flg <= 0)
		olvas(fplist,pflist,sizeof(pflist));
	if(flg >= 0)
		olvas(fpxref,pxlist,sizeof(pxlist));
	}
//flzar(argv[1],0,fplist);
//flzar(argv[2],0,fpxref);
fclose(fplist);
fclose(fpxref);
return(0);
}


static void olvas(FILE *fp,char *puffer, int hossz)
{
int c;

while((c=fgetc(fp)) != EOF && c != '\n')
	{	// fgets-nel nem tudtam megallapitani, tul hosszu-e a sor
	if(c == '\r' || c == '\t')
		hossz = -1;
	if(hossz-- > 1)
		*puffer++ = c;
	}
*puffer = 0;
}
